if not AltManager then return end

local quests_old, quests_old2 = nil, nil

function AltManager:QuestUpdateHandle()
		local quests = {}
		local i = 1
		while GetQuestLogTitle(i) do
			local _, _, _, _, isHeader, _, isComplete, _, questID = GetQuestLogTitle(i)
			if not isHeader then 
				quests[questID] = { complete = isComplete or 0 }
			end
			i = i + 1
		end
		
		if tC(quests_old) > tC(quests) then
			-- Lost a quest
			for k,v in pairs(quests_old) do
				if not (quests[k]) then
					if (quests_old[k].complete == 1 or quests_old2[k].complete == 1) then
						self:Quest_Completed(k)
						self:Printf("Quest completed : %s", k)
					else
						self:Quest_Abandoned(k)
						self:Printf("Quest abandonned : %s", k)
					end
				end
			end
		elseif tC(quests_old) < tC(quests) then
			-- Gained a quest
			for k,v in pairs(quests) do
				if not (quests_old[k]) then
					self:Quest_Gained(k)
					self:Printf("Quest gained : %s", k)
				end
			end
		else
			for k,v in pairs(quests) do
				self:Printf("No change : %s - %s", k, quests[k].complete)
			end
		end
		
		if not quest_old then
			quests_old2 = quests
		else
			quests_old2 = quests_old
		end
		quests_old = quests
	-- end
end

function tC(array)
	if (array) then
		local i = 0
		for k,v in pairs(array) do
			i = i+1
		end
		return i
	end
	return 0
end